/**********************************************************************
Copyright (c) 2013 Andy Jefferson and others. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Contributors:
    ...
**********************************************************************/
package javax.persistence.jpa21;

import javax.persistence.metamodel.Attribute;
import java.util.List;

/**
 * This type represents a AttributeNode of an EntityGraph that corresponds to a Managed Type.
 */
public interface Subgraph<T> extends AttributeNode<T> 
{
    public void addAttributeNodes(String ... attributeName);

    public void addAttributeNodes(Attribute<T, ?> ... attribute);

    public <X> Subgraph<X> addSubgraph(Attribute<T, X> attribute);

    public <X> Subgraph<? extends X> addSubgraph(Attribute<T, X> attribute, Class<? extends X> type);

    public <X> Subgraph<X> addSubgraph(String attributeName);

    public <X> Subgraph<X> addSubgraph(String attributeName, Class<X> type);

    public <X> Subgraph<X> addKeySubgraph(Attribute<T, X> attribute);

    public <X> Subgraph<? extends X> addKeySubgraph(Attribute<T, X> attribute, Class<? extends X> type);

    public <X> Subgraph<X> addKeySubgraph(String attributeName);

    public <X> Subgraph<X> addKeySubgraph(String attributeName, Class<X> type);

    public List<AttributeNode<?>> getAttributeNodes();

    public Class<T> getClassType();
}
